% Make a blank avw image.
%
% function avw=avw_blank(options) 
% 
% options=struct() with fields
%     pixdim =voxel dimensions
%     dim =Number of voxels in each direction
%     name =Name of the image
%     fill_pixel = pixel value to fill the image with
% 
function avw=avw_blank(options)
    if (nargin<1)
        avw=[]; return;
    end
    
    pixdim =options.pixdim;
    dim =options.dim;
    name =options.name;
    fill_pixel =options.fill_pixel;
    datatype='int16';
    if (isfield(options,'datatype'))
        datatype =options.datatype;
    end
    
    avw = avw_hdr_make;
    avw.hdr.dime.dim(2:4) = dim;
    avw.hdr.dime.pixdim(2:4)  = pixdim;
    if (strcmp(datatype,'int16'))
        avw.hdr.dime.datatype       = int16(4);%int16
        avw.hdr.dime.bitpix         = int16(16);%int16
        avw.hdr.dime.glmax          = int32(intmax('int16'));
        avw.hdr.dime.glmin          = int32(intmin('int16'));
    elseif (strcmp(datatype,'uint8'))
        avw.hdr.dime.datatype       = int16(2);%uint8
        avw.hdr.dime.bitpix         = int16(8);%uint8
        avw.hdr.dime.glmax          = int32(intmax('uint8'));
        avw.hdr.dime.glmin          = int32(intmin('uint8'));
    else
        error
    end
    avw.fileprefix = name;
    avw.img = zeros(options.dim,datatype)+eval([datatype '(fill_pixel);']);
    
end
