% Fill rectangular block
%
% function avw=avw_fill_block(avw,options)
%
% options=struct() with fields
%     lower=corner # 1, in left-handed Cartesian coordinates
%     upper=corner #2, in left-handed Cartesian coordinates
%     fill_pixel=fill region with this pixel value
% 
function avw=avw_fill_block(avw,options)

    lower=min([options.lower;options.upper]);
    upper=max([options.lower;options.upper]);
    fill_pixel=options.fill_pixel;

    Low= floor(lower./avw.hdr.dime.pixdim(2:4));
    High= ceil(upper./avw.hdr.dime.pixdim(2:4));

    i= max([Low(1),1]):min([High(1),double(avw.hdr.dime.dim(2))]);
    j= max([Low(2),1]):min([High(2),double(avw.hdr.dime.dim(3))]);
    k= max([Low(3),1]):min([High(3),double(avw.hdr.dime.dim(4))]);
    avw.img(i,j,k) = fill_pixel;

end

