% Fill circular cylinder
%
% function avw=avw_fill_cylinder(avw,options)
%
% options=struct() with fields
%     R=Radius, in left-handed Cartesian coordinates
%     Length=options.Length, in left-handed Cartesian coordinates
%     center=center, in left-handed Cartesian coordinates
%     Axis_direction=vector, in left-handed Cartesian coordinates 
%     fill_pixel=fill region with this pixel value
% %    
function avw=avw_fill_cylinder(avw,options)
    
    R=options.R;
    Length=options.Length;
    center=options.center;
    Axis_direction=options.Axis_direction;
    fill_pixel=options.fill_pixel;
    
    W =sqrt(R^2+Length^2);
    Low= floor((center-W)./avw.hdr.dime.pixdim(2:4))-1;
    High= ceil((center+W)./avw.hdr.dime.pixdim(2:4))+1;
    
    Axis_direction =Axis_direction/norm(Axis_direction);
    
    for i= max([Low(1),1]):min([High(1),double(avw.hdr.dime.dim(2))])
        for j= max([Low(2),1]):min([High(2),double(avw.hdr.dime.dim(3))])
            for k= max([Low(3),1]):min([High(3),double(avw.hdr.dime.dim(4))])
                v= double(avw.hdr.dime.pixdim(2:4)).*double([i,j,k]-0.5)- center;
                va = dot(v,Axis_direction);
                if  (abs(va) < Length/2)
                    vR = norm(v-va*Axis_direction);
                    if  (vR < R)
                        avw.img(i,j,k) = fill_pixel;
                    end
                end
            end
        end
    end
end
