% Fill ellipsoid
%
% function avw=avw_fill_ellipsoid(avw,options)
%
% options=struct() with fields
%     R=Radius, in left-handed Cartesian coordinates
%     center=center, in left-handed Cartesian coordinates
%     fill_pixel=fill region with this pixel value
% 
function avw=avw_fill_ellipsoid(avw,options)
    
    R=options.R;
     n=options.n;
    center=options.center;
    fill_pixel=options.fill_pixel;
    
    if (size(R)==[1, 3])
        R=R';
    end
    if (size(center)==[1, 3])
        center=center';
    end
   
    Low= floor((center-max(R))'./avw.hdr.dime.pixdim(2:4))-1
    High= ceil((center+max(R))'./avw.hdr.dime.pixdim(2:4))+1
    
    for i= max([Low(1),1]):min([High(1),double(avw.hdr.dime.dim(2))])
        for j= max([Low(2),1]):min([High(2),double(avw.hdr.dime.dim(3))])
            for k= max([Low(3),1]):min([High(3),double(avw.hdr.dime.dim(4))])
                p=(double(avw.hdr.dime.pixdim(2:4)).*double([i,j,k]-0.5))';
                v= (n'*(p- center))./R;
                if  (v'*v <= 1)
                    avw.img(i,j,k) = fill_pixel;
                end
            end
        end
    end
end
