% Fill parallelepiped
% 
% function avw=avw_fill_parallelepiped(avw,options)
%
% options=struct() with fields
%     E1,E2,E3=the parallelepiped is defined by three vectors
%     origin=origin is the point from which the three vectors emanate
%     fill_pixel=fill region with this pixel value
% 
function avw=avw_fill_parallelepiped(avw,options)

    origin=reshape(options.origin,1,3);% row vector
    L1=norm(options.E1);
    E1=reshape(options.E1,3,1)/L1;% unit column vector
    L2=norm(options.E2);
    E2=reshape(options.E2,3,1)/L2;% unit column vector
    L3=norm(options.E3);
    E3=reshape(options.E3,3,1)/L3;% unit column vector
    fill_pixel=options.fill_pixel;

    A=inv( [E1, E2, E3 ] )';
    
    for i= 1:double(avw.hdr.dime.dim(2))
        for j= 1:double(avw.hdr.dime.dim(3))
            for k= 1:double(avw.hdr.dime.dim(4))
                p=(double(avw.hdr.dime.pixdim(2:4)).*double([i,j,k]-0.5))- origin;
                c1= (p*A(:,1));
                if  (c1 >= 0) && (c1 <= L1)
                    c2= (p*A(:,2));
                    if  (c2 >= 0) && (c2 <= L2)
                        c3= (p*A(:,3));
                        if  (c3 >= 0) && (c3 <= L3)
                            avw.img(i,j,k) = fill_pixel;
                        end
                    end
                end
            end
        end
    end

end

