% Fill sphere
%
% function avw=avw_fill_sphere(avw,options)
%
% options=struct() with fields
%     R=Radius, in left-handed Cartesian coordinates
%     center=center, in left-handed Cartesian coordinates
%     fill_pixel=fill region with this pixel value
% 
function avw=avw_fill_sphere(avw,options)
    
    R=options.R;
    center=options.center;
    fill_pixel=options.fill_pixel;
    
    Low= floor((center-R)./avw.hdr.dime.pixdim(2:4))-1;
    High= ceil((center+R)./avw.hdr.dime.pixdim(2:4))+1;
    
    for i= max([Low(1),1]):min([High(1),double(avw.hdr.dime.dim(2))])
        for j= max([Low(2),1]):min([High(2),double(avw.hdr.dime.dim(3))])
            for k= max([Low(3),1]):min([High(3),double(avw.hdr.dime.dim(4))])
                v= double(avw.hdr.dime.pixdim(2:4)).*double([i,j,k]-0.5)- center;
                if  (v*v' < R^2)
                    avw.img(i,j,k) = fill_pixel;
                end
            end
        end
    end
end
