function newavw = resample_avw(avw, factors)
    if (sum(factors)==length(factors))&&(prod(factors)==1)
        newavw=avw;
        return;% Nothing to be done
    end
    % Create the data structure; need to be tweaked next
    newavw.hdr =avw.hdr;
    newavw.fileprefix =avw.fileprefix;
    newavw.img =[];

    % Adjust the number of dimensions and the pixel dimensions
    if size(factors)== [3, 1]
        factors = factors';
    end
    newavw.hdr.dime.dim(2:4) =ceil(double(avw.hdr.dime.dim(2:4))./factors);
    newavw.hdr.dime.pixdim(2:4)=(double(avw.hdr.dime.dim(2:4)).*double(avw.hdr.dime.pixdim(2:4)))./double(newavw.hdr.dime.dim(2:4));

    % Create the new image
    newavw.img =zeros(newavw.hdr.dime.dim(2:4),class(avw.img(1, 1, 1)));
    tempimg =zeros([newavw.hdr.dime.dim(2:3),avw.hdr.dime.dim(4)], class(avw.img(1, 1, 1)));

    EXTRAPVAL=0;
    try
        [m,n,p] =size(avw.img);
        newm=(newavw.hdr.dime.dim(2));    newn=(newavw.hdr.dime.dim(3));    newp=(newavw.hdr.dime.dim(4));
        [XI,YI,ZI] = ndgrid(m/double(newm)*double(1:newm),n/double(newn)*double(1:newn),p/double(newp)*double(1:newp));
        newavw.img = interpn(double(avw.img),XI,YI,ZI,'linear',EXTRAPVAL);
    catch% if the above fields for memory shortage
        % Re-interpolate each slice
        newm=(newavw.hdr.dime.dim(2));    newn=(newavw.hdr.dime.dim(3));
        for i= 1: size(tempimg,3)
            tempimg(:,:,i) = resample2 ((avw.img(:,:,i)),newm,newn);
        end
        
        % re-interpolate in the third dimension
        newp=(newavw.hdr.dime.dim(4));
        %     newavw.img =resample3(tempimg,newp);
        for i= 1: size(tempimg,1)
            for j= 1: size(tempimg,2)
                v =(resample1(squeeze(tempimg(i,j,:)),newp))';
                newavw.img(i,j,:) =v;
            end
        end
    end

    % Resample a 2-D slice.
    function newimage = resample2 (image2d,newm,newn)
        [m,n] =size(image2d);
        [XI,YI] = ndgrid(m/double(newm)*double(1:newm),n/double(newn)*double(1:newn));
        newimage = interpn(double(image2d),XI,YI,'linear',EXTRAPVAL);
    end
    
    
    function newdata = resample1(data,newp)
        [p] =length(data);
        newdata = interp1(double(data),double(p)/double(newp)*double(1:newp));%X,Y,XI,METHOD,EXTRAPVAL
    end
end
